Upd: fixed author's solution links.
Sorry for the slow Editorial, I am new using Polygon.
Special thanks to TechNite for his help.
About one hour before the contest Retired_cherry found the same problem, then we changed it to $$$k=4$$$ and he found another same one again. We are running out of time so we didn't have time for a new one, so we changed $$$k$$$ to $$$5$$$. But we didn't know there is still a similar problem. Sorry again.
idea:gyh20 solution:gyh20 tutorial:TechNite
Jury solution:92671575
idea: feecIe6418 solution:feecIe6418 tutorial:feecIe6418
Jury solution:92671590
idea:gyh20 solution:gyh20 tutorial:feecIe6418
Jury solution:92671713
idea:isaf27 solution:gyh20 tutorial:TechNite
Jury solution:92671763
idea:gyh20 solution:gyh20 tutorial:gyh20
Jury solution:92671740
Thanks for the fast editorial! It was an amazing contest (besides problem B)!
UPD: Problem E editorial has a typo: tutotial -> tutorial.
Hi, in 1406B — Maximum Product, after sorting in descending order, i think it is feasible to check only 3 values that are 5 entries from top and none from bottom, 3 from top and 2 from bottom, 1 from top and 4 from bottom and then simply find their max :)
Yes, I did that way, you can see my submissions. I just said that because problem B could be easily googled.
Oh okay, i thought you got stuck somewhere :)
How to prove that this will give the correct answer always? pls help
Ok so we need to find a maximum product of five numbers, right? Now, sort the given array in descending order so that big positive numbers(if any) are in front and big negatives are in last(if any)and consider the following cases:- 1. If all numbers are negative, then the product of the first 5 would be the answer. eg. -1,-2,-3,-4,-5,-6 2. If all numbers are positive, then also the product of the first 5 will be the answer. eg. 5,4,3,2,1,0 Now see if there is a mixture of even and odd numbers, for the product to be maximum negative numbers should be multiplied even number of times, so I will simply consider negative numbers 0 times, 2 times, 4 times, and 5 times(if only all numbers are negative). You can check my solution also for effective implementation. https://codeforces.me/contest/1406/submission/92589865
Couldn't solve E, but it was interesting(atleast to me).
Auto comment: topic has been updated by gyh20 (previous revision, new revision, compare).
Link is still wrong now.
The solution link is not working sir!!!.. Please check it once. Thank you
Fixed.
I don't think it is fixed.It says that you are not allowed(even I am logged in)
could you please check?
still not working
fixed
Auto comment: topic has been updated by gyh20 (previous revision, new revision, compare).
nice problems, liked the centroid concept!! .... hope to see more like this
I used a different approach for C: 1. First I found the tree diameter. 2. Then I rooted the tree at one of the centres (if there are 2) and calculated the subtree sizes. 3. Then for each node of the tree diameter, I calculated the maximum subtree size that would be generated when I remove that node. 4. I found the minima over all these subtree sizes, the node/s which give this minima are the centroids. 5. If there is a unique centroid, I removed any edge and rejoined it. Else, I took a leaf, removed the edge between it and the parent, and joined it to one of the centroids. I don't know why my solution fails at test case 6. https://codeforces.me/contest/1406/submission/92644162 Thanks in advance.
The centroid(s) does not necessarily lie on diameter.
Thanks, Can you please explain me C, I didn't understand the editorial.
If there are two centroids, they are adjacent and divide the tree into two components of size $$$\dfrac{n}{2}$$$ and $$$\dfrac{n}{2} - 1$$$.
Pick a leaf from the subtree ( not containing the other centroid ) of any one of the centroids and link it with the other.
why are there at most 2 centroids? Also, why do they have to be adjacent? An informal proof will be much appreciated! Thanks in advance.
If you agree with the fact that 2 centroids must be adjacent to each other, then if there exists another centroid it must be adjacent to the previous 2 centroids but that will lead to a cycle. Therefore, there are at the most 2 centroids.
Ah! Very smart! But again, why do the centroids have to be adjacent?
If not, choose any other vertex on the path from one of the centroids to the other, and the size of the largest connected component after cutting it will be smaller than the original ones.
And that is a contradiction.
great thanks!
you can look up any centroid decomposition tutorials online. these are briefly explained over there.
Right! Thanks a lot!
A few typos in the first line of the solution explanation for problem D. It should be:
Since sequence $$$b$$$ is non-decreasing and sequence $$$c$$$ is non-increasing, we need to find $$$max(c_1, b_n)$$$.
@ivanzuki can you explain me is there any need of suml in the tutorial part, please? and what is wrong with my solution can you help me to find out? solution link : https://codeforces.me/contest/1406/submission/93036847
Change
int check()
tolong long check()
and you get AC :)I had a different and much simpler approach to B.
Firstly, sort the array from smallest to largest (no absolute value). After the sort, it can be proved that the answer is either a[n-1]*a[n-2]*a[n-3]*a[n-4]*a[n-5], a[n-1]*a[n-2]*a[n-3]*a[1]*a[0], or a[n-1]*a[3]*a[2]*a[1]*a[0]. Take the maximum of these three values as the answer. The logic is pretty self explanatory.
My submission: 92587656
I had a slightly more complicated to code but really easy to understand.
I took the first 10 numbers and the last 10 numbers of the sorted array(handling the case when $$$1 \le n \le 20$$$). Then I bruteforced through all the combinations of 5 numbers from the 20 numbers. I then took the maximum of all of those products.
Link to submission 92660785. Please tell me if you don't understand my code because of all of the macros.
"maxinum component size of x" it should say "maximum component size of x" (for problem C)
I have a slightly different solution for E using binary search that might be more intuitive. First, brute force all prime factors which are $$$\leq \sqrt{n}$$$, for $$$n = 1e5$$$, there are only $$$65$$$ such primes, and we can check each exponent for all in ~$$$200$$$ queries(even less if we binary search on the exponent). Then, for the higher primes only one such prime can appear, so we binary search on the rest of the primes with the following algorithm:
Let $$$num$$$ be the amount of numbers left in the set.
Consider some search space of primes $$$[l, r]$$$
Ask B for all primes $$$[l, mid]$$$, subtract the result of the query from $$$num$$$
Ask A 1
If the result of A 1 and $$$num$$$ differ, the last prime is in the range $$$[l, mid]$$$, otherwise it is in the range $$$[mid+1, r]$$$
This part takes at most $$$m + log(m), m = \pi(n)$$$ queries so it easily passes.
After you ask B for all primes in [l,mid], how can you find the right factor if the result of A 1 and num differ?
Harshlyn94's method does work, but you can also continue to binary search that range, and so you don't need to write another check. Its not much of an implementation save, but it is a little easier.
I found a submission that uses this idea: 92651206
.
I thought that there should be atmost most 2 centroids in a tree is it correct?
If it is how to prove it ? And if it's not then why, I was not able to find an example.
Assume that node x is one of the centroids of the tree.
Make x the root of the tree
Here, we denote sz(a) as size of the subtree of a
According to definition, sz(child of x) ≤ (n / 2). (1)
We have another observation: The size of the subtree of a node < size of the subtree of its parent (2)
If there are one centroid => We are done
Else, let y be another centroid of the tree.
When we delete y, the subtree that doesn't contain the subtree of y is connected, so its size must ≤ (n / 2) according to definition
=> sz(y) ≥ (n / 2) (3)
From (1), (2) and (3), sz(y) = (n / 2) and y is a direct child of x
If there is another node z which is another centroid of the tree (now we have 3 centroids), then sz(y) + sz(z) + 1 (node x itself) = n + 1, and since y and z are directed childs of x, their subtrees don't share any node.
=> The graph has ≥ (n + 1) node (contradiction)
=> There are at most 2 centroids in a tree (Q.E.D)
"**When we delete y, the subtree that doesn't contain the subtree of y is connected, so its size must ≤ (n / 2) according to definition**"
I don't get this, what is the subtree that doesn't contain the subtree of y ?
The subtree that doesn't contain the subtree of y is the given tree without the subtree of node y.
thanks
SpeedForces
GoogleForces
CopyPasteForces
B and C seemed rather standard. I recognized B as an E problem from a recent ABC round. However, I didn't bother to go looking for it and then copy and paste a solution. For D, I googled "how to find centroid of a tree" and "how many centroids are in a tree". The latter gave me
A tree may have one centroid or may have two centroids. If it has two centroids, they are always connected (otherwise, the tree can't have n vertices). You can find these vertices by checking the size of each subtree, doing DFS.
Which basically trivialized the problem.
Nevertheless, A, D, and E seem quite nice. I found this round rather interesting (especially problems D and E).
We are sorry for making problem B.
But for C, the point of the problem is not to find the centroids, but what to do next. So in my opinion, I don't think C is very standard.
Can anyone tell me why my code is giving runtime error on test 1?
https://codeforces.me/contest/1406/submission/92659872
it's because your centroid finding function is not working, centroid vector is empty and consequently indexing empty vector causes runtime error
I know that some values are inserting to the vector, but sometimes this vector is empty. I struggle with fixing this bug. Do you know what exactly is not working in this function?
There might be other problems too but one of the obvious thing is
if(n - graf_size[u] > n / 2)
this check should be outside loopfor(auto v : graf[u])
so that you check condition only when you have calculated actual subtree size for node u.Edit : I made some more changes to
Centroid
function. now it seems to work. correct submission : solutionIn E I believe you should add $$$\sqrt{m}$$$ to your estimate. You do $$$\sqrt{m} \cdot \sqrt{m} + 1 \cdot \sqrt{m}$$$ and in at most 2 buckets you'll find a prime that divides $$$x$$$, so you need to add $$$2 \cdot \sqrt{m}$$$ for that. And later there is that $$$\log_2(n)$$$ and one for answer, so counting this way we get $$$m + 3\sqrt{m} + \log(n)$$$.
Also I don't understand why the first 3 paragraphs of its tutorial are there, in my opinion they are quite confusing.
I don't understand why we can't find the smallest prime number by using the given method. Shouldn't it be largest prime number which is not possible to find.
We can find all prime divisors this way, editorial is just confusing.
Can someone explain this line from the editorial of question E. After finishing asking a group, ask A 1 and check if the return value same as it supposed to be without x.
First, if all numbers are less than 0, then you should print the product of the five biggest numbers of them. Otherwise, the maximum product must be non-negative
. Its false. How about -1 1 2 3 4?It will only make sense if n > 5.
Problem D. Three Sequences Youtube Video Explanation in Hindi. Solution Explanation Youtube Link
If SomeOne is Upsolving Problem D and needed some help in solution explanation in hindi. please watch above video and give feedback to improve quality. Thanks
can anyone explain solution of 3rd problem? I can't understand why dfs is used here?Can it be solved without dfs like if we can find out 2 centroids by checking the largest component which is smallest by removing each vertex one by one and than if there are 2 or more centroids we can remove one edge from one centroid and connect to other centroid??
How do you find a centroid without doing dfs?
I think by removing each vertex one by one and than checking for largest component than does not contain removed vertex and out of these components the centroids will be the ones that has minimum size component (obtained after removing those vertex). Please correct me if i am wrong.I can't understand how dfs is applied here to find centroid.It will be of great help if u could provide any source to solve this type of problems
It is well explained in this blog https://codeforces.me/blog/entry/57593
I did not know this algo before the contest, and implemented an alternative. Just find foreach vertex the maximum size of the subtree of its adjent vertex. Then find among all vertex the one or both with minimum value. 92620542
I think the problem C and E is interesting,but problem A is not easy enough to put it on A.It can be B.
Can anyone tell me why my code is wrong?(Problem E)
https://codeforces.ml/contest/1406/submission/92640804
About centroids. Editorial says "If not, choose any other vertex on the path from x to y and the size of the largest connected component after cutting it will be smaller than x and y". Looks like this is impossible and centroids are always connected. If I am correct, please remove this confusing comment
yeah ... I also think so.
The point of that statement is proving, by contradiction, that "centroids are always connected".
I cannot see the Jury's solution for E. It shows "You are not allowed to view the requested page".
I think there are some typos in the editorial of problem D:
sequence $$$b$$$ is non-decreasing and $$$c$$$ is non-increasing (as in the problem description).
and then, it should say $$$\max(c_1, b_n)$$$.
Will fix that soon
About problem E:
I didn't notice that $$$1\le a\le n$$$!
What a pity!I almost made it to the top 20!
emmm, you are sure that you can solve E if you notice $$$1\le a\le n$$$ that time?
I passed the problem after I saw $$$1\le a\le n$$$. :(
Same here. I noticed the constraint after the contest. The solution I submitted during the contest ACed when I added the condition.
Auto comment: topic has been updated by feecIe6418 (previous revision, new revision, compare).
I can't view pC's solution(submission), does it only happen to my account or is it private ><
Though I've lost so many ratings,I enjoy the contset very much.
THX for such a wonderful contest!!!
Does anyone have a neat proof that definition of the centroid given in C matches the standard definition of centroid (disconnecting it separates the tree into connected components all <= n/2 in size)?
Let us root the tree at centroid (curren't problem's definition of centroid), and sz(x) be the size of subtree of vertex x, now sz(x) is the smallest possible largest connected component upon deleting a vertex s, now assume sz(x) > (n/2), now the largest connected component upon deleting x would be max(n-sz(x), max(sz(y1))) where y1 are x's children, sz(y1)<sz(x) and n-sz(x) < n/2 (as sz(x) > n/2), so either way the sz(x) would not be the smallest possible largest connected component and hence s is not the centroid, hence a contradiction. We can extend this to say that both the centroids should by adjacent, with the equation sz(x) + sz(y) = n (where y is another centroid)
Excellent. Although hard to wrap my mind around "We can extend this to say both centroids must be adjacent". Could you explain a bit more? Thanks!
Tree is still rooted at s, there is some other centroid out there y, let it's children be yi, now the largest component upon deleting y is max(sz(yi),n-sz(y)), now sz(yi) < sz(x) so if this also centroid, then n-sz(y) = sz(x), as both produce the smallest possible largest component, hence sz(x) + sz(y) = n, but sz(x)<=n/2, and sz(y)<=sz(x) as upon deleting the root, the largest component we get itself is sz(x), the only scenario where the above eqns can be satisfied is sz(x) = sz(y) = n/2 and y is child of s, but if y!=x then sum of subtree's of child itself becomes n, so the only way out is y equals x. So there can be atmost 2 centroids, both adjacent.
Thanks!
Can someone find me a video editorial for problem C. Thanks in advance!
Watch this video by SecondThread
can anyone help ,where my logic get wrong for B. Maximum Product https://codeforces.me/contest/1406/submission/92678443
In Maximum Product(B) it is written that i<j<k<l<t .. then why sorting ? It will definitely change the order.
If i>j,then you can see j as i,and i as j.
It doesn't makes any sense to me
i <j <k <l <t just means that you have to pick 5 numbers(from distinct indices). Moreover, you just want to find the max. product , so you need not worry about "indices".
Can someone tell what is wrong in my solution for problem B. It is giving me WA on test 2 for the 143rd input.Thanks in advance.
https://codeforces.me/contest/1406/submission/92649674
consider the test case : -1 -2 -3 -4 -5 -6 your code gives -720 but the answer is -120.
There is another solution for problem
B
withdynamic programming
. That approach seems not to be the easiest one, but I would like to share it just in case it may be interesting for someone.Submission: 92600395.
Nice round! Thanks~
In Problem B, I am getting wrong answer on test 2, more specifically on 143rd input — answer is not matching . Can anyone please point me out where I am going wrong? Link to submission — https://codeforces.me/contest/1406/submission/92680690
Consider the test case: -6 -5 -4 -3 -2 -1. Your code gives -720 but the answer should be -120.
My solution for C :
If there are two centroids, I pick one of the centroids and disconnect one of its non-centroid subtree and connect that subtree to the other centroid. Will this always work?
My submission : 92632074
can anybody tell this?
Does anyone knows any good tutorial/blog for finding the centroid of a tree?
The answer you seek is one google search away
I am only finding about centroid decompostion(other than 1 CF blog). Is it the same ?
This blog is quite nice. Very short and has interesting problems. Try to solve all. You will learn much quicker via solving problems than just reading theory.
Hi, in 1406B — Maximum Product, after sorting in descending order, i think it is feasible to check only 3 values that are 5 entries from top and none from bottom, 3 from top and 2 from bottom, 1 from top and 4 from bottom and then simply find their max :)
Am I the only one who tried solving D using range updates and range maximum queries? I feel stupid.
For problem D, how to prove that this arrangement will be optimal and gives us the least possible max(c1,bn) ? For example say d = a(i) — a(i-1), when d > 0, b(i) = b(i-1) + y(aribitary y), c(i) = c(i-1) + d — y(arbitary y), how to prove that in the optimal solution y = 0 ?
isaf27 gyh20 TechNite
For every i>1, you just want to minimize b(i) and maximize c(i), when y=0, this is the optimal.
Thanks, but in the editorial, shouldn't it be a(r+1)-a(r) instead of a(r) — a(r-1) ? both a(r) and a(r-1) change by x
will fix that soon,thanks.
In a tree, the center of the diameter and the centroid are different points, right? Please give me an example, I am unable to come up with one... Thanks in advance
For question 3
can anyone give me an example tree with more than 2 centroids? my assert(n<=2) statement is failing.
I solved [problem:1460E] in another way: "B i" for every prime in (n/2, n], then "A 1", check is your cnt equal to this: if not: "A i" == 1 for every prime in (n/2, n] -> ans *= i; else take (n/4, n/2] ...
And in the end check primes from (1, n / ans)
I mention that primes in (1, n/2] > (n/2, n], that's why you won't have more than enough queries
But the author's solution with sqrt-decomposition is better and easier — Sorry for the waste of time ))) Wanted to let you know about other solution :)
I think the total number of operations for E is around $$$M + \sqrt{M} \cdot log(M) + log(M)$$$
UPD : sorry I was wrong.
Can problem D find legal arrays of $$$b$$$ and $$$c$$$? upd:Oh, yes, it can be done.
In Problem C in the case of 2 centroids, instead of finding a leaf in a centroid and attaching to the other centroid I found an edge from a centroid other than the one joining the two centroids and attached it to the other centroid. My solution passed system tests. Is it right or is there any test case for which my solution fails?
It's right.
problem B's tutotial: while the maxinum component size of x is still $$$\frac{n}{2}$$$.
I think it should be: while the maxinum component size of x is $$$\frac{n}{2}$$$ or $$$\frac{n}{2}-1$$$.
Since x is parent of y, won't maximum component size of x become n/2 -1 always? How will it be n/2?
I am not sure I completely understand problem D. I have been trying for past 3 days but the queries part is not clear to me and the solutions I refer to also are not understandable Can someone please explain the queries part, how are we updating the elements in the range l..r or if not, then why not? I understood why we need only the two adjacent differences in every query but what about updating the elements? Please help me.I would appreciate it.
Can someone please explain how the updates are being made in editorial's solution? I looked at many codes but I am unable to understand anything from them? Please help me!!! I understood the rest of the solution.
can anyone explain the editorial of problem A. and why i got runtime error herehttps://codeforces.me/contest/1406/submission/93185539
I posted an explanation: https://www.youtube.com/watch?v=bQ1jIuTNib0. Thank you!
Is problem A wrong? Why not split the set (0 2 1 5 0 1) into (0 0 2 5) and (1 1) to have mex of 1 and 0 respectively?
Because in that case, the answer will be 0 + 1 = 1. Our goal is to maximize the sum of the Mex functions on the subsets. For a split (0, 1, 2) and (0, 1, 5) we will have 3 and 2 retrospectively and will get 5, which is greater than 1.
I recorded a short video explaining this: https://www.youtube.com/watch?v=bQ1jIuTNib0
Thank you!
Hi guys, this is our solution for problem A. We would be happy to hear your feedback regarding the format. Thank you!
feecIe6418 For the problem 1406B - Maximum Product, you have asked to sort the given array based on the absolute values from big to small. And still how can the time complexity be O(N)?
Can anyone tell me why there is a Compilation error with GNU 17c++ and not with GNU 14c++ for same code.
GNU 17 c++ code -193989828
GNU 14 c++ code — 193989946
Can Problem B be solved using DP ? let dp[i][j] be maximum possible product using first i numbers and choosing j numbers of them to product them , where (1<=i<=n,1<=j<=5)?
https://codeforces.me/blog/entry/82500?#comment-694826
C. Link Cut Centroids with rerooting
Hello, can someone help me in question C, my submission is : 281910274
i don't know why my code is failing on testcase 5, and also if anyone can give me a small testcase where my code will not work.
first, i try to find the centroids and then i check the max component and if there is 2 centroid, i removed leaf node from one and add it to another node, and if only 1 centroid is there, then i remove and add the same edge.
Thanks in advance.